#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SortByField {
    #[serde(rename = "NAME")]
    Name,
    #[serde(rename = "CREATED_AT")]
    CreatedAt,
    #[serde(rename = "UPDATED_AT")]
    UpdatedAt,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SortByField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SortByField::Name => "NAME",
            SortByField::CreatedAt => "CREATED_AT",
            SortByField::UpdatedAt => "UPDATED_AT",
            SortByField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SortByField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SortByField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SortByField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<SortByField, conjure_object::plain::ParseEnumError> {
        match v {
            "NAME" => Ok(SortByField::Name),
            "CREATED_AT" => Ok(SortByField::CreatedAt),
            "UPDATED_AT" => Ok(SortByField::UpdatedAt),
            v => v.parse().map(|v| SortByField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SortByField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SortByField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SortByField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
